﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Com.Piwigo.Wpf.Helper;
using Com.Piwigo.Wpf.Command;
using Com.Piwigo.Wpf.DTO;

namespace Com.Piwigo.Wpf
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            PwgCmdEvents.CmdRunningChanged += new PwgCmdEvents.CmdRunningChangedHandler(PwgCmdEventsConsumer.PwgCmdEvents_CmdRunningChanged);
            PwgCmdEvents.CmdSendUiInfo += new PwgCmdEvents.CmdSendUiInfoHandler(PwgCmdEventsConsumer.PwgCmdEvents_CmdSendUiInfo);
        }

        private void listViewCategory_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            AppHelper.ExecuteCommand<PwgCmdGetImageforCategory>(listViewCategory.SelectedValue);
        }

        private void listViewImage_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (PwgCmdSelectImageInCategory.Command.CanExecute(sender))
            {
                PwgCmdSelectImageInCategory.Command.Execute(sender);
            }
        }

        private void listViewCategory_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            e.Handled = false;
            DependencyObject dep = (DependencyObject)e.OriginalSource;
            while ((dep != null) && !(dep is TreeViewItem))
            {
                dep = VisualTreeHelper.GetParent(dep);
            }
            if (dep != null)
            {
                if (((TreeViewItem)dep).DataContext is PwgCategoryWPF)
                {
                    PwgCategoryWPF aCat = (PwgCategoryWPF)((TreeViewItem)dep).DataContext;

                    if ((e.ChangedButton == MouseButton.Left) && (e.ClickCount == 1))
                    {
                        // left single click event
                        if (aCat.Childrens == null)
                        {
                            AppHelper.ExecuteCommand<PwgCmdGetSubCategorieforCategory>(aCat);
                        }
                    }
                }
            }
        }


    }
}
